#include "usbadm.h"
#include <device.h>
#include <parser.h>

int addserial (int ac, char **av)
{
	FILE *f;
	char *serial = NULL;
	char *file = NULL;

	if (ac >= 3)
		serial = av[2];

	if (!serial) {
		while ((file = find_proc_file ())) {
			if (!(f = fopen (file, "r"))) {
				free (file);
				continue;
			}
			printf ("[+] procfile: %s\n", file);

			serial = get_param(f, "Serial Number", ':');

			if (serial && 
			    !strncmp (serial, "None", strlen("None"))) {
				free (serial);
				serial = NULL;
			}

			if (!serial) {
				printf ("[-] serial number: none\n");
				
				/* fall back to GUID */
				if (!(serial = get_param (f, "GUID", ':'))) {
					fclose (f);
					free (file);
					printf ("[-] GUID: none\n");
					continue;
				}
				
				printf ("[+] GUID: %s\n", serial);
				serial = insert_before ("{G} ", serial);
				
			} else {
				printf ("[+] serial number: %s\n", serial);
				serial = insert_before ("{S} ", serial);
			}

			printf ("[+] auth number: %s\n", serial);
			
			if (!check_param (f, "Attached", "Yes", ':')) {
				fclose (f);
				free (file);
				free (serial);
				serial = NULL;
				printf ("[-] attached: no\n");
				continue;
			}
			printf ("[+] attached: yes\n");
			break;
		}
	}
		
	if (!serial) {
		printf ("[-] Cannot retrieve the serial number\n");
		return 1;
	}

	if (!(f = fopen (usb_conf.snfile, "a"))) {
		printf ("cannot open file %s\n", usb_conf.snfile);
		return 1;
	}

	printf ("[!] Allowing serial number %s...", serial);
	fflush (stdout);

	if (fputs (serial, f) == EOF) {
		printf ("[-] cannot write file %s\n", usb_conf.snfile);
		return 1;
	}
	fputc ('\n', f);
	printf ("done.\n");

	return 0;
}








